Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cv_driver.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/cv_driver.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cv_driver.F	(revision 633)
@@ -5,7 +5,9 @@
      &                   t1,q1,qs1,u1,v1,tra1,
      &                   p1,ph1,iflag1,ft1,fq1,fu1,fv1,ftra1,
-     &                   precip1,
+     &                   precip1,VPrecip1,
      &                   cbmf1,sig1,w01,
-     &                   delt,Ma1,upwd1,dnwd1,dnwd01,qcondc1,wd1,cape1)
+     &                   icb1,inb1,
+     &                   delt,Ma1,upwd1,dnwd1,dnwd01,qcondc1,wd1,cape1,
+     &                   da1,phi1,mp1)
 C
       implicit none
@@ -37,4 +39,5 @@
 C      ftra1         Real           Output       tracor tend
 C      precip1       Real           Output       precipitation
+C      VPrecip1      Real           Output       vertical profile of precipitations
 C      cbmf1         Real           Output       cloud base mass flux
 C      sig1          Real           In/Out       section adiabatic updraft
@@ -84,4 +87,5 @@
       real precip1(len)
       real cbmf1(len)
+      real VPrecip1(len,nd+1)
       real Ma1(len,nd)
       real upwd1(len,nd)
@@ -93,4 +97,6 @@
       real cape1(len)     
 
+      real da1(len,nd),phi1(len,nd,nd),mp1(len,nd)
+      real da(len,nd),phi(len,nd,nd),mp(len,nd)
       real tra1(len,nd,ntra)
       real ftra1(len,nd,ntra)
@@ -185,4 +191,6 @@
 !  precip: Scalar convective precipitation rate (mm/day).
 !
+!  VPrecip: Vertical profile of convective precipitation (kg/m2/s).
+!
 !  wd:   A convective downdraft velocity scale. For use in surface
 !        flux parameterizations. See convect.ps file for details.
@@ -213,4 +221,5 @@
       integer nk1(klon)
       integer icb1(klon)
+      integer inb1(klon)
       integer icbs1(klon)
 
@@ -267,5 +276,5 @@
       real ments(nloc,klev,klev), qents(nloc,klev,klev)
       real sij(nloc,klev,klev), elij(nloc,klev,klev)
-      real mp(nloc,klev), qp(nloc,klev), up(nloc,klev), vp(nloc,klev)
+      real qp(nloc,klev), up(nloc,klev), vp(nloc,klev)
       real wt(nloc,klev), water(nloc,klev), evap(nloc,klev)
       real b(nloc,klev), ft(nloc,klev), fq(nloc,klev)
@@ -275,4 +284,5 @@
       real tps(nloc,klev), qprime(nloc), tprime(nloc)
       real precip(nloc)
+      real VPrecip(nloc,klev+1)
       real tra(nloc,klev,ntra), trap(nloc,klev,ntra)
       real ftra(nloc,klev,ntra), traent(nloc,klev,klev,ntra)
@@ -321,6 +331,8 @@
          tp1(i,k)=0.0
          clw1(i,k)=0.0
+cym
+         clw(i,k)=0.0	 
          gz1(i,k) = 0.
-
+         VPrecip1(i,k) = 0.
          Ma1(i,k)=0.0
          upwd1(i,k)=0.0
@@ -344,4 +356,5 @@
         wd1(i)=0.0
         cape1(i)=0.0
+        VPrecip1(i,nd+1)=0.0
  60   continue
 
@@ -550,5 +563,5 @@
      :                     ,ment,qent,uent,vent,nent,elij,traent,sig
      :                     ,tv,tvp
-     o                     ,iflag,precip,ft,fq,fu,fv,ftra
+     o                     ,iflag,precip,VPrecip,ft,fq,fu,fv,ftra
      o                     ,upwd,dnwd,dnwd0,ma,mike,tls,tps,qcondc,wd)
       endif
@@ -566,18 +579,34 @@
 
 !^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+! --- passive tracers
+!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+
+      if (iflag_con.eq.3) then
+       CALL cv3_tracer(nloc,len,ncum,nd,nd,
+     :                  ment,sij,da,phi)
+      endif
+
+!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 ! --- UNCOMPRESS THE FIELDS
 !^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
-
-
+c set iflag1 =42 for non convective points 
+      do  i=1,len
+        iflag1(i)=42
+      end do
+c
       if (iflag_con.eq.3) then
        CALL cv3_uncompress(nloc,len,ncum,nd,ntra,idcum
      :          ,iflag
-     :          ,precip,sig,w0
+     :          ,precip,VPrecip,sig,w0
      :          ,ft,fq,fu,fv,ftra
+     :          ,inb 
      :          ,Ma,upwd,dnwd,dnwd0,qcondc,wd,cape
+     :          ,da,phi,mp
      o          ,iflag1
-     o          ,precip1,sig1,w01
+     o          ,precip1,VPrecip1,sig1,w01
      o          ,ft1,fq1,fu1,fv1,ftra1
-     o          ,Ma1,upwd1,dnwd1,dnwd01,qcondc1,wd1,cape1 )
+     o          ,inb1
+     o          ,Ma1,upwd1,dnwd1,dnwd01,qcondc1,wd1,cape1 
+     o          ,da1,phi1,mp1)
       endif
 
@@ -609,5 +638,5 @@
 c -- si .TRUE., on rend la gravite plus explicite et eventuellement
 c differente de 10.0 dans convect3: 
-      cvflag_grav = .FALSE.
+      cvflag_grav = .TRUE.
 
       return
@@ -652,5 +681,6 @@
 c ori      t0  = RTT
        t0  = 273.15 ! convect3 (RTT=273.16)
-       grav= 10.    ! implicitely or explicitely used in convect3
+c maf       grav= 10.    ! implicitely or explicitely used in convect3
+       grav= g    ! implicitely or explicitely used in convect3
       endif
 
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cvltr.F
===================================================================
--- LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cvltr.F	(revision 633)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cvltr.F	(revision 633)
@@ -0,0 +1,144 @@
+c
+c $Header$
+c
+      SUBROUTINE cvltr(pdtime,da, phi, mp,paprs,pplay,x,upd,dnd,dx)
+      IMPLICIT NONE 
+c=====================================================================
+c Objet : convection des traceurs / KE
+c Auteurs: M-A Filiberti and J-Y Grandpeix
+c=====================================================================
+c
+#include "dimensions.h"
+#include "dimphy.h"
+#include "YOMCST.h"
+#include "YOECUMF.h" 
+c
+      REAL pdtime
+      REAL paprs(klon,klev+1) ! pression aux 1/2 couches (bas en haut)
+      REAL pplay(klon,klev)  ! pression pour le milieu de chaque couche
+      REAL x(klon,klev)        ! q de traceur (bas en haut) 
+      REAL dx(klon,klev)     ! tendance de traceur  (bas en haut)
+      real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
+      REAL upd(klon,klev)      ! saturated updraft mass flux
+      REAL dnd(klon,klev)      ! saturated downdraft mass flux
+c
+c--variables locales      
+      real zed(klon,klev),zmd(klon,klev,klev)
+      real za(klon,klev,klev)
+      real zmfd(klon,klev),zmfa(klon,klev)
+      real zmfp(klon,klev),zmfu(klon,klev)
+      integer i,k,j 
+c test conservation
+c      real conserv
+c =========================================
+c calcul des tendances liees au downdraft
+c =========================================
+      zed(:,:)=0.
+      zmfd(:,:)=0.
+      zmfa(:,:)=0.
+      zmfu(:,:)=0.
+      zmfp(:,:)=0.
+      zmd(:,:,:)=0.
+      za(:,:,:)=0.
+c entrainement
+      do k=1,klev-1
+        do i=1,klon
+          zed(i,k)=max(0.,mp(i,k)-mp(i,k+1))
+        end do
+      end do
+c
+c calcul de la matrice d echange
+c matrice de distribution de la masse entrainee en k
+c
+      do k=1,klev
+        do i=1,klon
+          zmd(i,k,k)=zed(i,k)
+        end do
+      end do
+      do k=2,klev
+        do j=k-1,1,-1
+          do i=1,klon
+          if(mp(i,j+1).ne.0) then
+          zmd(i,j,k)=zmd(i,j+1,k)*min(1.,mp(i,j)/mp(i,j+1))
+          endif
+          end do
+        end do
+      end do
+      do k=1,klev
+        do j=1,klev-1
+          do i=1,klon
+          za(i,j,k)=max(0.,zmd(i,j+1,k)-zmd(i,j,k))
+          end do
+        end do
+      end do
+c
+c rajout du terme lie a l ascendance induite
+c
+        do j=2,klev
+         do i=1,klon
+          za(i,j,j-1)=za(i,j,j-1)+mp(i,j)
+         end do
+        end do
+C
+c tendances
+c            
+      do k=1,klev
+        do j=1,klev
+          do i=1,klon
+          zmfd(i,j)=zmfd(i,j)+za(i,j,k)*(x(i,k)-x(i,j))
+          end do
+        end do
+      end do
+c
+c =========================================
+c calcul des tendances liees aux flux satures
+c =========================================
+      do j=1,klev
+        do i=1,klon
+          zmfa(i,j)=da(i,j)*(x(i,1)-x(i,j))
+        end do
+      end do
+      do k=1,klev
+        do j=1,klev
+          do i=1,klon
+          zmfp(i,j)=zmfp(i,j)+phi(i,j,k)*(x(i,k)-x(i,j))
+          end do
+        end do
+      end do
+      do j=1,klev-1
+        do i=1,klon
+          zmfu(i,j)=max(0.,upd(i,j+1)+dnd(i,j+1))*(x(i,j+1)-x(i,j))
+        end do
+      end do
+      do j=2,klev
+        do i=1,klon
+          zmfu(i,j)=zmfu(i,j)
+     .             +min(0.,upd(i,j)+dnd(i,j))*(x(i,j)-x(i,j-1))
+        end do
+      end do
+
+c =========================================
+c--calcul final des tendances
+c =========================================
+      do k=1, klev
+        do i=1, klon
+          dx(i,k)=(zmfd(i,k)+zmfu(i,k)
+     .      +zmfa(i,k)+zmfp(i,k))*pdtime
+     .      *RG/(paprs(i,k)-paprs(i,k+1))
+c          print*,'dx',k,dx(i,k)
+        enddo
+      enddo
+c
+c test de conservation du traceur
+c      conserv=0.
+c      do k=1, klev
+c        do i=1, klon
+c         conserv=conserv+dx(i,k)*
+c     .     (paprs(i,k)-paprs(i,k+1))/RG
+C
+c        enddo
+c      enddo
+c      print *,'conserv',conserv
+     
+      return
+      end
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/dimphy.F90
===================================================================
--- LMDZ4/branches/LMDZ4_par_0/libf/phylmd/dimphy.F90	(revision 633)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/dimphy.F90	(revision 633)
@@ -0,0 +1,313 @@
+module dimphy
+
+  
+  logical, save :: monocpu
+!  logical, save :: parallel
+   
+  INTEGER,SAVE :: iiphy_begin
+  INTEGER,SAVE :: iiphy_end
+  INTEGER,SAVE :: jjphy_begin
+  INTEGER,SAVE :: jjphy_end
+  INTEGER,SAVE :: jjphy_nb
+  INTEGER,SAVE :: ijphy_begin
+  INTEGER,SAVE :: ijphy_end
+  INTEGER,SAVE :: ijphy_nb
+  INTEGER,SAVE :: klon_begin
+  INTEGER,SAVE :: klon_end
+  
+  
+  INTEGER,SAVE,allocatable,dimension(:) :: jjphy_para_nb
+  INTEGER,SAVE,allocatable,dimension(:) :: jjphy_para_begin
+  INTEGER,SAVE,allocatable,dimension(:) :: jjphy_para_end
+  INTEGER,SAVE,dimension(:),allocatable :: Liste_i
+  INTEGER,SAVE,dimension(:),allocatable :: Liste_j
+  INTEGER,SAVE,dimension(:),allocatable :: klon_para_nb
+  INTEGER,SAVE,dimension(:),allocatable :: klon_para_begin
+  INTEGER,SAVE,dimension(:),allocatable :: klon_para_end 
+
+  
+  INTEGER,save :: phy_rank
+  INTEGER,save :: phy_size
+  
+
+  INTEGER,save :: klev, klevp1,klevm1,klon,kfdia,kidia
+  INTEGER,save :: klon2
+  INTEGER,save :: nbtr 
+  INTEGER,save :: kdlon, kflev
+  REAL,save,allocatable,dimension(:) :: zmasq
+  
+
+  
+contains
+  
+   subroutine InitDimphy
+   use parallel
+   implicit none
+#include "dimensions90.h"
+#include "paramet90.h" 
+    integer :: rank
+    integer :: i,j,Pos,Index
+    logical,save :: First=.true.
+
+#ifdef CPP_PARALLEL      
+      monocpu=.false.
+#else
+      monocpu = .true.
+#endif
+      
+      if (monocpu) then
+        
+	phy_rank=0
+	phy_size=1
+	
+#ifdef CPP_PARALLEL      
+      else
+ 
+        phy_rank=mpi_rank
+	phy_size=mpi_size
+#endif
+      
+      endif
+
+      if (First) then
+        allocate(jjphy_para_nb(0:phy_size-1))
+        allocate(jjphy_para_begin(0:phy_size-1))
+        allocate(jjphy_para_end(0:phy_size-1))
+        allocate(klon_para_nb(0:phy_size-1))
+        allocate(klon_para_begin(0:phy_size-1))
+        allocate(klon_para_end(0:phy_size-1))
+      endif
+	
+      klev=llm
+      klevp1=klev+1
+      klevm1=klev-1
+      klon2=iim*(jjm-1)+2
+      
+     
+!        do i=0,phy_size-1
+!          klon_para_nb(i)=(klon2/phy_size)
+!          if (i<MOD(klon2,phy_size)) klon_para_nb(i)=klon_para_nb(i)+1
+!          if (i==0) then 
+!            klon_para_begin(i)=1
+!          else 
+!            klon_para_begin(i)=klon_para_end(i-1)+1
+!          endif
+!          klon_para_end(i)=klon_para_begin(i)+klon_para_nb(i)-1
+!        enddo
+      
+      if (First) then
+        do i=0,phy_size-1
+          klon_para_nb(i)=(klon2/phy_size)
+          if (i<MOD(klon2,phy_size)) klon_para_nb(i)=klon_para_nb(i)+1
+        enddo
+      endif
+        
+      do i=0,phy_size-1
+        if (i==0) then 
+          klon_para_begin(i)=1
+        else 
+          klon_para_begin(i)=klon_para_end(i-1)+1
+        endif
+        klon_para_end(i)=klon_para_begin(i)+klon_para_nb(i)-1
+      enddo
+	
+      klon=klon_para_nb(phy_rank)
+      klon_begin=klon_para_begin(phy_rank)
+      klon_end=klon_para_end(phy_rank)
+	
+      nbtr=nqmx-2+1/(nqmx-1)
+
+      kidia=1
+      kfdia=klon
+      
+      if (klon==6818 .and. monocpu) then
+        kdlon=487
+      else
+        kdlon=klon
+      endif
+      kflev=klev
+    
+      if (.not.first) then
+        deallocate(zmasq,liste_i,liste_j)
+      endif
+      
+      allocate(zmasq(klon))
+
+      
+      allocate(Liste_i(klon))
+      allocate(Liste_j(klon))
+    
+      Index=1
+      if (Pole_Nord) then
+        Liste_i(1)=1
+        Liste_j(1)=1
+        iiphy_begin=1
+        jjphy_begin=1
+	ijphy_begin=1
+        Index=Index+1
+      endif
+    
+      Pos=2
+      do j=2,jjm
+        do i=1,iim
+      
+	  if (Pos==klon_begin) then
+            iiphy_begin=i
+            jjphy_begin=j
+	    ijphy_begin=j*iip1+i
+          endif
+       
+          if (Pos==klon_end) then
+            iiphy_end=i
+            jjphy_end=j
+	    ijphy_end=j*iip1+i
+          endif
+        
+          if (Pos>=klon_begin .AND. Pos<=klon_end) then
+            Liste_i(Index)=i
+            Liste_j(Index)=j
+            Index=Index+1
+          endif
+          Pos=Pos+1
+        enddo
+      enddo
+    
+      if (pole_sud) then
+        Liste_i(Index)=1
+        Liste_j(Index)=jjp1
+        iiphy_end=1
+        jjphy_end=jjp1
+	ijphy_end=jjp1*iip1+1
+      endif
+    
+      ijphy_nb=ijphy_end-ijphy_begin+1
+      jjphy_nb=jjphy_end-jjphy_begin+1
+	
+	    
+      Pos=2
+      rank=0
+      jjphy_para_begin(rank)=1
+    
+      do j=2,jjm
+        do i=1,iim
+          if (Pos==klon_para_begin(rank)) then
+            jjphy_para_begin(rank)=j
+          endif
+          if (Pos==klon_para_end(rank)) then
+            jjphy_para_end(rank)=j
+            rank=rank+1
+          endif
+          Pos=Pos+1
+        enddo
+      enddo
+      jjphy_para_end(rank)=jjp1
+      
+      First=.false.    
+   end subroutine InitDimphy
+   
+
+   subroutine GatherField(Fields,Fieldr,ll)
+     implicit none
+#ifdef CPP_PARALLEL      
+     include 'mpif.h'
+#endif
+     INTEGER :: ll
+     REAL, dimension(klon,ll) :: Fields
+     REAL, dimension(klon2,ll) :: Fieldr     
+     REAL, dimension(klon2*ll) :: Field_tmp     
+     INTEGER, dimension(0:phy_size-1) :: displs
+     INTEGER, dimension(0:phy_size-1) :: sendcounts
+     INTEGER :: l,Pos,rank,ierr
+     INTEGER :: klon_b,klon_e, Nb
+     
+     Pos=1     
+     do rank=0,phy_size-1
+       klon_b=klon_para_begin(rank)
+       klon_e=klon_para_end(rank)
+       Nb=klon_para_nb(rank)
+       displs(rank)=Pos-1
+       sendcounts(rank)=Nb*ll
+       Pos=Pos+Nb*ll
+     enddo
+         
+      if (monocpu) then
+        Fieldr(:,:)=Fields(:,:)
+#ifdef CPP_PARALLEL      
+      else
+        call MPI_Gatherv(Fields,klon*ll,MPI_REAL8,Field_tmp,sendcounts,  &
+	                 displs,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
+#endif
+      endif
+      
+     Pos=1     
+     do rank=0,phy_size-1
+       klon_b=klon_para_begin(rank)
+       klon_e=klon_para_end(rank)
+       Nb=klon_para_nb(rank)
+       do l=1,ll
+         Fieldr(klon_b:klon_e,l)=Field_tmp(Pos:Pos+Nb-1)
+	 Pos=Pos+Nb
+       enddo
+     enddo
+      
+   end subroutine GatherField
+
+   subroutine AllGatherField(Fields,Fieldr,ll)
+     implicit none
+#ifdef CPP_PARALLEL      
+     include 'mpif.h'
+#endif   
+     INTEGER :: ll
+     REAL, dimension(klon,ll) :: Fields
+     REAL, dimension(klon2,ll) :: Fieldr     
+     
+     INTEGER :: ierr
+
+#ifdef CPP_PARALLEL             
+     call GatherField(Fields,Fieldr,ll)
+     call MPI_BCAST(Fieldr,klon2*ll,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
+#endif   
+   end subroutine AllGatherField
+   
+           
+   subroutine ScatterField(Fields,Fieldr,ll)
+     implicit none
+#ifdef CPP_PARALLEL      
+     include 'mpif.h'
+#endif
+     INTEGER :: ll
+     REAL, dimension(klon2,ll) :: Fields
+     REAL, dimension(klon,ll) :: Fieldr     
+     REAL, dimension(klon2*ll) :: Field_tmp     
+     INTEGER, dimension(0:phy_size-1) :: displs
+     INTEGER, dimension(0:phy_size-1) :: sendcounts
+     INTEGER :: l,Pos,rank,ierr
+     INTEGER :: klon_b,klon_e, Nb
+
+     Pos=1    
+     do rank=0,phy_size-1
+       klon_b=klon_para_begin(rank)
+       klon_e=klon_para_end(rank)
+       Nb=klon_para_nb(rank)
+       displs(rank)=Pos-1
+       sendcounts(rank)=Nb*ll
+       do l=1,ll
+         Field_tmp(Pos:Pos+Nb-1)=Fields(klon_b:klon_e,l)
+	 Pos=Pos+Nb
+       enddo
+     enddo
+           
+     if (monocpu) then
+       Fieldr(:,:)=Fields(:,:)
+     else
+#ifdef CPP_PARALLEL      
+       call MPI_Scatterv(Field_tmp,sendcounts,displs,MPI_REAL8,         &
+	                 Fieldr,klon*ll,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
+#endif
+     endif
+      
+        
+   end subroutine ScatterField
+   
+   
+end module dimphy
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/fisrtilp.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/fisrtilp.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/fisrtilp.F	(revision 633)
@@ -123,5 +123,7 @@
 c
       DATA appel1er /.TRUE./
-
+cym
+      zdelq=0.0
+      
       IF (appel1er) THEN
 c
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ini_histday.h
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/ini_histday.h	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ini_histday.h	(revision 633)
@@ -270,5 +270,5 @@
      .                "ave(X)", zsto,zout)
 c
-         CALL histdef(nid_day, "vitw", "Vertical wind", "m/s",
+         CALL histdef(nid_day, "vitw", "Vertical wind", "Pa/s",
      .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ini_histhf.h
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/ini_histhf.h	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ini_histhf.h	(revision 633)
@@ -113,9 +113,15 @@
      .                "ave(X)", zsto1,zout)
 c
-c
+c -- LOOP
          CALL histdef(nid_hf, "SWdownOR",
-     .                "Sfce incident SW radiation OR", "W/m^2",
-     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
-     .                "ave(X)", zsto1,zout)
+     .                "Sfce incident SW down radiation OR", "W/m^2",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
+     .                "ave(X)", zsto1,zout)
+c
+         CALL histdef(nid_hf, "SWnetOR",
+     .                "Sfce incident SW net radiation OR", "W/m^2",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
+     .                "ave(X)", zsto1,zout)
+c -- LOOP
 c
          CALL histdef(nid_hf, "LWdownOR",
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ini_histmth.h
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/ini_histmth.h	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ini_histmth.h	(revision 633)
@@ -443,9 +443,10 @@
      .                "ave(X)", zsto,zout)
 c
+      ENDIF !iflag_con .GE. 3
+c
          CALL histdef(nid_mth, "prw", "Precipitable water", "kg/m2",
      .                iim,jjmp1,nhori, 1,1,1, -99, 32,
      .                "ave(X)", zsto,zout)
 c
-      ENDIF !iflag_con .GE. 3
 c34EK
 c
@@ -463,5 +464,5 @@
 c
           CALL histdef(nid_mth, "w"//clev(k),
-     .                 "Vertical wind"//clev(k)//"mb","m/s",
+     .                 "Vertical wind"//clev(k)//"mb","Pa/s",
      .                iim,jjmp1,nhori, 1,1,1, -99, 32,
      .                "ave(X)", zsto,zout)
@@ -512,5 +513,5 @@
      .                "ave(X)", zsto,zout)
 c
-         CALL histdef(nid_mth, "vitw", "Vertical wind", "m/s",
+         CALL histdef(nid_mth, "vitw", "Vertical wind", "Pa/s",
      .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
@@ -534,8 +535,4 @@
 c
          CALL histdef(nid_mth, "ozone", "Ozone concentration", "-",
-     .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
-     .                "ave(X)", zsto,zout)
-c
-         CALL histdef(nid_mth, "upwd", "saturated updraft", "kg/m2/s",
      .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
@@ -593,8 +590,14 @@
      .                "ave(X)", zsto,zout)
 c
+      IF (iflag_con.GE.3) THEN 
+c
          CALL histdef(nid_mth,"Ma","undilute adiab updraft","kg/m2/s",
      .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 c
+         CALL histdef(nid_mth, "upwd", "saturated updraft", "kg/m2/s",
+     .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+c
          CALL histdef(nid_mth, "dnwd", "saturated downdraft","kg/m2/s",
      .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
@@ -604,4 +607,6 @@
      .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
+      ENDIF !iflag_con.GE.3
+c
 c
          CALL histdef(nid_mth, "dtdyn", "Dynamics dT", "K/s",
@@ -739,19 +744,10 @@
 c     endif
 c
-c        CALL histdef(nid_mth, "ozone", "Ozone concentration", "-",
-c    .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
-c    .                "ave(X)", zsto,zout)
-c
          if (nqmax.GE.3) THEN
-         DO iq=1,nqmax-2
-         IF (iq.LE.99) THEN
-         WRITE(str2,'(i2.2)') iq
-         CALL histdef(nid_mth, "trac"//str2, "Tracer No."//str2, "-",
-     .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
-     .                "ave(X)", zsto,zout)
-         ELSE
-         PRINT*, "Trop de traceurs"
-         CALL abort
-         ENDIF
+         DO iq=3,nqmax
+         iiq=niadv(iq)
+         CALL histdef(nid_mth, tnom(iq), ttext(iiq), "-",
+     .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
          ENDDO
          ENDIF
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ini_histrac.h
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/ini_histrac.h	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ini_histrac.h	(revision 633)
@@ -87,5 +87,5 @@
      .                "ave(X)", zsto,zout)
 
-#ifdef INCA_CH4
+#ifdef INCA
 #ifdef INCAINFO
          DO it=1, phtcnt
@@ -224,8 +224,25 @@
      .              "ave(X)", zsto,zout)
          endif
-#endif
-         ENDDO
+
+c---Ajout Olivia
+         CALL histdef(nid_tra, "d_tr_th_"//tnom(iq),
+     .	              "tendance thermique"// ttext(iiq), "?",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "d_tr_cv_"//tnom(iq),
+     .	              "tendance convection"// ttext(iiq), "?",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "d_tr_cl_"//tnom(iq),
+     .	              "tendance couche limite"// ttext(iiq), "?",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+c---fin Olivia	 
+
+#endif
+         ENDDO
+
 #ifdef INCA
-#ifdef INCA_CH4
+!#ifdef INCA_CH4
          CALL histdef(nid_tra, "O3_column", "O3_column",
      .           "DU", iim,jjm+1,nhori, 1,1,1, -99, 32,
@@ -258,5 +275,79 @@
 !    .                "t_sum(X)", zsto,zout)
 
-#endif
+!#ENDIF
+
+!! Ajout Anne
+#ifdef INCA_AER
+! for sulfur cycle
+         CALL histdef(nid_tra, "SO2_p_dmsoh", "SO2_p_dmsoh", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "SO2_p_dmsno3", "SO2_p_dmsno3", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "SO2_p_h2soh", "SO2_p_h2soh", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "SO2_p_dmsooh", "SO2_p_dmsooh", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "DMSO_p_dmsoh", "DMSO_p_dmsoh", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "ASMSAM_p_dmsooh", "ASMSAM_p_dmsooh", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "ASSO4M_p_so2oh", "ASSO4M_p_so2oh", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "ASSO4M_p_so2h2o2", "ASSO4M_p_h2o2","CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "ASSO4M_p_so2o3", "ASSO4M_p_so2o3", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+
+         CALL histdef(nid_tra, "Wet3D_SO2", "Wet3D_SO2",
+     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .           "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "Wet3D_DMS", "Wet3D_DMS",
+     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .           "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "Wet3D_HNO3", "Wet3D_HNO3",
+     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .           "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "Wet3D_H2O2", "Wet3D_H2O2",
+     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .           "ave(X)", zsto,zout)
+
+         CALL histdef(nid_tra, "PH_HIST", "pH over physics time step", "1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+#endif
+
+#ifdef INCA_NMHC
+         CALL histdef(nid_tra, "CO2_basprod", "CO2_basprod", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "CO2_nmhcprod", "CO2_nmhcprod", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "CO2_radicalprod", "CO2_radicalprod", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "HNO3_prod", "HNO3_prod", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "HNO3_loss", "HNO3_loss", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "CO_prod", "CO_prod", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "CO_loss", "CO_loss", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+#endif
+! Fin ajout Anne
 #else
          CALL histdef(nid_tra, "pyu1", "Vent niv 1", "-",
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/initphysto.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/initphysto.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/initphysto.F	(revision 633)
@@ -188,7 +188,17 @@
 c coefh frac_impa,frac_nucl
 	
-	call histdef(fileid, 'coefh', ' ', ' ',
-     .             iim, jjm+1, nhoriid, llm, 1, llm, zvertiid,
-     .             32, 'inst(X)', t_ops, t_wrt)
+	call histdef(fileid, "coefh", " ", " ",
+     .             iim, jjm+1, nhoriid, llm, 1, llm, zvertiid,
+     .             32, "inst(X)", t_ops, t_wrt)
+
+c abderrahmane le 16 09 02
+        call histdef(fileid, "fm_th", " ", " ",
+     .             iim, jjm+1, nhoriid, llm, 1, llm, zvertiid,
+     .             32, "inst(X)", t_ops, t_wrt)
+
+        call histdef(fileid, "en_th", " ", " ",
+     .             iim, jjm+1, nhoriid, llm, 1, llm, zvertiid,
+     .             32, "inst(X)", t_ops, t_wrt)
+c fin aj
 	
 	write(*,*) 'apres coefh ds initphysto'	
@@ -283,5 +293,6 @@
 
       call histend(fileid)
-      if (ok_sync) call histsync(fileid)
+c     if (ok_sync) call histsync(fileid)
+      if (ok_sync) call histsync
 
 	
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/initrrnpb.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/initrrnpb.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/initrrnpb.F	(revision 633)
@@ -74,6 +74,4 @@
       DO i = 1,klon
         masktr(i,it) = 0.
-c       IF ( NINT(pctsrf(i,3)) .EQ. 1 ) masktr(i,it) = 1.
-c       fshtr(i,it) = s * masktr(i,it) * pctsrf(i,3)
         IF ( NINT(pctsrf(i,1)) .EQ. 1 ) masktr(i,it) = 1.
         fshtr(i,it) = s * masktr(i,it)
